<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-pragma">{-# LANGUAGE DataKinds           #-}</span><span>
</span><span id="line-2"></span><span class="hs-pragma">{-# LANGUAGE FlexibleContexts    #-}</span><span>
</span><span id="line-3"></span><span class="hs-pragma">{-# LANGUAGE LambdaCase          #-}</span><span>
</span><span id="line-4"></span><span class="hs-pragma">{-# LANGUAGE OverloadedStrings   #-}</span><span>
</span><span id="line-5"></span><span class="hs-pragma">{-# LANGUAGE PolyKinds           #-}</span><span>
</span><span id="line-6"></span><span class="hs-pragma">{-# LANGUAGE RecordWildCards     #-}</span><span>
</span><span id="line-7"></span><span class="hs-pragma">{-# LANGUAGE ScopedTypeVariables #-}</span><span>
</span><span id="line-8"></span><span class="hs-pragma">{-# LANGUAGE TypeApplications    #-}</span><span>
</span><span id="line-9"></span><span class="hs-pragma">{-# LANGUAGE TypeFamilies        #-}</span><span>
</span><span id="line-10"></span><span class="hs-pragma">{-# LANGUAGE TypeOperators       #-}</span><span>
</span><span id="line-11"></span><span>
</span><span id="line-12"></span><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">Hyperion.Bootstrap.OPESearch.FormQueries</span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-13"></span><span>
</span><span id="line-14"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Control.Applicative</span></span><span>                           </span><span class="hs-special">(</span><span class="annot"><span class="hs-operator">(&lt;|&gt;)</span></span><span class="hs-special">)</span><span>
</span><span id="line-15"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Control.Monad.Catch</span></span><span>                           </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">catch</span></span><span class="hs-special">)</span><span>
</span><span id="line-16"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Control.Monad.Except</span></span><span>                          </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">runExceptT</span></span><span class="hs-special">)</span><span>
</span><span id="line-17"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Control.Monad.Trans.Maybe</span></span><span>                     </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">MaybeT</span></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-18"></span><span>                                                                </span><span class="annot"><span class="hs-identifier">runMaybeT</span></span><span class="hs-special">)</span><span>
</span><span id="line-19"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Data.List.NonEmpty</span></span><span>                            </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">NonEmpty</span></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-20"></span><span>                                                                </span><span class="annot"><span class="hs-operator">(&lt;|)</span></span><span class="hs-special">)</span><span>
</span><span id="line-21"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">Data.List.NonEmpty</span></span><span>                            </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">NE</span></span><span>
</span><span id="line-22"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">Data.Matrix.Static</span></span><span>                            </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">M</span></span><span>
</span><span id="line-23"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Data.Proxy</span></span><span>                                    </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">Proxy</span></span><span class="hs-special">)</span><span>
</span><span id="line-24"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Data.Ratio</span></span><span>                                    </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">approxRational</span></span><span class="hs-special">)</span><span>
</span><span id="line-25"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Fmt</span></span><span>                                           </span><span class="hs-special">(</span><span class="annot"><span class="hs-operator">(+||)</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-operator">(||+)</span></span><span class="hs-special">)</span><span>
</span><span id="line-26"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">GHC.TypeNats</span></span><span>
</span><span id="line-27"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">Hyperion.Log</span></span><span>                                  </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">Log</span></span><span>
</span><span id="line-28"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.BoolFunction.html"><span class="hs-identifier">Hyperion.Bootstrap.BoolFunction</span></a></span><span>                </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">B</span></span><span>
</span><span id="line-29"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html"><span class="hs-identifier">Hyperion.Bootstrap.OPESearch.BilinearForms</span></a></span><span>     </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#BilinearForms"><span class="hs-identifier">BilinearForms</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-30"></span><span>                                                                </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#midMaxPositiveInterval"><span class="hs-identifier">midMaxPositiveInterval</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-31"></span><span>                                                                </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#positiveInterval"><span class="hs-identifier">positiveInterval</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-32"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.HessianLineSearch.html"><span class="hs-identifier">Hyperion.Bootstrap.OPESearch.HessianLineSearch</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.HessianLineSearch.html#DescentConfig"><span class="hs-identifier">DescentConfig</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-33"></span><span>                                                                </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.HessianLineSearch.html#DescentResult"><span class="hs-identifier">DescentResult</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-34"></span><span>                                                                </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.HessianLineSearch.html#HessianLineSearchError"><span class="hs-identifier">HessianLineSearchError</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-35"></span><span>                                                                </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.HessianLineSearch.html#LineSearchType"><span class="hs-identifier">LineSearchType</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-36"></span><span>                                                                </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.HessianLineSearch.html#descentSearchRandomized"><span class="hs-identifier">descentSearchRandomized</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-37"></span><span>                                                                </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.HessianLineSearch.html#hessianLineSearchAverage"><span class="hs-identifier">hessianLineSearchAverage</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-38"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Linear.V</span></span><span>                                      </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">V</span></span><span class="hs-special">)</span><span>
</span><span id="line-39"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Numeric.Rounded</span></span><span>                               </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">Rounded</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier">RoundingMode</span></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-40"></span><span>                                                                </span><span class="annot"><span class="hs-identifier">reifyPrecision</span></span><span class="hs-special">)</span><span>
</span><span id="line-41"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">QuadraticNet</span></span><span>                                  </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">QN</span></span><span>
</span><span id="line-42"></span><span>
</span><span id="line-43"></span><span id="local-6989586621679449874"><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#queryAllowedBoolFunction"><span class="hs-identifier hs-type">queryAllowedBoolFunction</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Monad</span></span><span> </span><span class="annot"><a href="#local-6989586621679449874"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#BilinearForms"><span class="hs-identifier hs-type">BilinearForms</span></a></span><span> </span><span class="annot"><span class="hs-number">2</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679449874"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Maybe</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">V</span></span><span> </span><span class="annot"><span class="hs-number">2</span></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Rational</span></span><span class="hs-special">)</span><span class="hs-special">)</span></span><span>
</span><span id="line-44"></span><span id="queryAllowedBoolFunction"><span class="annot"><span class="annottext">queryAllowedBoolFunction :: BilinearForms 2 -&gt; m (Maybe (V 2 Rational))
</span><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#queryAllowedBoolFunction"><span class="hs-identifier hs-var hs-var">queryAllowedBoolFunction</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#BilinearForms"><span class="hs-identifier hs-type">BilinearForms</span></a></span><span> </span><span id="local-6989586621679449871"><span class="annot"><span class="annottext">Double
</span><a href="#local-6989586621679449871"><span class="hs-identifier hs-var">res</span></a></span></span><span> </span><span id="local-6989586621679449870"><span class="annot"><span class="annottext">[(Maybe (V 2 Rational), Matrix 2 2 Rational)]
</span><a href="#local-6989586621679449870"><span class="hs-identifier hs-var">fs</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Maybe (V 2 Rational) -&gt; m (Maybe (V 2 Rational))
forall (m :: * -&gt; *) a. Monad m =&gt; a -&gt; m a
</span><span class="hs-identifier hs-var">return</span></span><span> </span><span class="annot"><span class="annottext">(Maybe (V 2 Rational) -&gt; m (Maybe (V 2 Rational)))
-&gt; Maybe (V 2 Rational) -&gt; m (Maybe (V 2 Rational))
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span>
</span><span id="line-45"></span><span>  </span><span class="hs-keyword">let</span><span> </span><span id="local-6989586621679449869"><span class="annot"><span class="annottext">positiveIntervals :: [BoolFunction Double]
</span><a href="#local-6989586621679449869"><span class="hs-identifier hs-var hs-var">positiveIntervals</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">((Maybe (V 2 Rational), Matrix 2 2 Rational)
 -&gt; BoolFunction Double)
-&gt; [(Maybe (V 2 Rational), Matrix 2 2 Rational)]
-&gt; [BoolFunction Double]
forall a b. (a -&gt; b) -&gt; [a] -&gt; [b]
</span><span class="hs-identifier hs-var">map</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Matrix 2 2 Double -&gt; BoolFunction Double
forall a. (Floating a, Ord a) =&gt; Matrix 2 2 a -&gt; BoolFunction a
</span><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#positiveInterval"><span class="hs-identifier hs-var">positiveInterval</span></a></span><span> </span><span class="annot"><span class="annottext">(Matrix 2 2 Double -&gt; BoolFunction Double)
-&gt; ((Maybe (V 2 Rational), Matrix 2 2 Rational)
    -&gt; Matrix 2 2 Double)
-&gt; (Maybe (V 2 Rational), Matrix 2 2 Rational)
-&gt; BoolFunction Double
forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">(Rational -&gt; Double) -&gt; Matrix 2 2 Rational -&gt; Matrix 2 2 Double
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-identifier hs-var">fmap</span></span><span> </span><span class="annot"><span class="annottext">Rational -&gt; Double
forall a. Fractional a =&gt; Rational -&gt; a
</span><span class="hs-identifier hs-var">fromRational</span></span><span> </span><span class="annot"><span class="annottext">(Matrix 2 2 Rational -&gt; Matrix 2 2 Double)
-&gt; ((Maybe (V 2 Rational), Matrix 2 2 Rational)
    -&gt; Matrix 2 2 Rational)
-&gt; (Maybe (V 2 Rational), Matrix 2 2 Rational)
-&gt; Matrix 2 2 Double
forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">(Maybe (V 2 Rational), Matrix 2 2 Rational) -&gt; Matrix 2 2 Rational
forall a b. (a, b) -&gt; b
</span><span class="hs-identifier hs-var">snd</span></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">[(Maybe (V 2 Rational), Matrix 2 2 Rational)]
</span><a href="#local-6989586621679449870"><span class="hs-identifier hs-var">fs</span></a></span><span>
</span><span id="line-46"></span><span>      </span><span id="local-6989586621679449867"><span class="annot"><span class="annottext">allowed :: BoolFunction Double
</span><a href="#local-6989586621679449867"><span class="hs-identifier hs-var hs-var">allowed</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(BoolFunction Double -&gt; BoolFunction Double -&gt; BoolFunction Double)
-&gt; BoolFunction Double
-&gt; [BoolFunction Double]
-&gt; BoolFunction Double
forall (t :: * -&gt; *) a b.
Foldable t =&gt;
(a -&gt; b -&gt; b) -&gt; b -&gt; t a -&gt; b
</span><span class="hs-identifier hs-var">foldr</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">BoolFunction Double -&gt; BoolFunction Double -&gt; BoolFunction Double
forall a.
Ord a =&gt;
BoolFunction a -&gt; BoolFunction a -&gt; BoolFunction a
</span><a href="Hyperion.Bootstrap.BoolFunction.html#and"><span class="hs-identifier hs-var">B.and</span></a></span><span> </span><span class="annot"><span class="annottext">(BoolFunction Double -&gt; BoolFunction Double -&gt; BoolFunction Double)
-&gt; (BoolFunction Double -&gt; BoolFunction Double)
-&gt; BoolFunction Double
-&gt; BoolFunction Double
-&gt; BoolFunction Double
forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">BoolFunction Double -&gt; BoolFunction Double
forall a. BoolFunction a -&gt; BoolFunction a
</span><a href="Hyperion.Bootstrap.BoolFunction.html#not"><span class="hs-identifier hs-var">B.not</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Bool -&gt; BoolFunction Double
forall a. Bool -&gt; BoolFunction a
</span><a href="Hyperion.Bootstrap.BoolFunction.html#fromConst"><span class="hs-identifier hs-var">B.fromConst</span></a></span><span> </span><span class="annot"><span class="annottext">Bool
</span><span class="hs-identifier hs-var">True</span></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">[BoolFunction Double]
</span><a href="#local-6989586621679449869"><span class="hs-identifier hs-var">positiveIntervals</span></a></span><span>
</span><span id="line-47"></span><span>  </span><span class="hs-keyword">in</span><span> </span><span class="annot"><span class="annottext">(V 2 Double -&gt; V 2 Rational)
-&gt; Maybe (V 2 Double) -&gt; Maybe (V 2 Rational)
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-identifier hs-var">fmap</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">(Double -&gt; Rational) -&gt; V 2 Double -&gt; V 2 Rational
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-identifier hs-var">fmap</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Double -&gt; Double -&gt; Rational
forall a. RealFrac a =&gt; a -&gt; a -&gt; Rational
</span><span class="hs-operator hs-var">`approxRational`</span></span><span> </span><span class="annot"><span class="annottext">Double
</span><a href="#local-6989586621679449871"><span class="hs-identifier hs-var">res</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">(Maybe (V 2 Double) -&gt; Maybe (V 2 Rational))
-&gt; Maybe (V 2 Double) -&gt; Maybe (V 2 Rational)
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">BoolFunction Double -&gt; Maybe (V 2 Double)
forall a. (Floating a, Ord a) =&gt; BoolFunction a -&gt; Maybe (V 2 a)
</span><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#midMaxPositiveInterval"><span class="hs-identifier hs-var">midMaxPositiveInterval</span></a></span><span> </span><span class="annot"><span class="annottext">BoolFunction Double
</span><a href="#local-6989586621679449867"><span class="hs-identifier hs-var">allowed</span></a></span><span>
</span><span id="line-48"></span><span>
</span><span id="line-49"></span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#queryAllowedQuadraticNet"><span class="hs-identifier hs-type">queryAllowedQuadraticNet</span></a></span><span>
</span><span id="line-50"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679449888"><span class="annot"><a href="#local-6989586621679449888"><span class="hs-identifier hs-type">j</span></a></span></span><span> </span><span class="hs-operator">.</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">KnownNat</span></span><span> </span><span class="annot"><a href="#local-6989586621679449888"><span class="hs-identifier hs-type">j</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">KnownNat</span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="#local-6989586621679449888"><span class="hs-identifier hs-type">j</span></a></span><span class="annot"><span class="hs-glyph hs-type">-</span></span><span class="annot"><span class="hs-number">1</span></span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-51"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">QN.QuadraticNetConfig</span></span><span>
</span><span id="line-52"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Double</span></span><span>
</span><span id="line-53"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#BilinearForms"><span class="hs-identifier hs-type">BilinearForms</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679449888"><span class="hs-identifier hs-type">j</span></a></span><span>
</span><span id="line-54"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Maybe</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">V</span></span><span> </span><span class="annot"><a href="#local-6989586621679449888"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Rational</span></span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-55"></span><span id="queryAllowedQuadraticNet"><span class="annot"><span class="annottext">queryAllowedQuadraticNet :: QuadraticNetConfig
-&gt; Double -&gt; BilinearForms j -&gt; IO (Maybe (V j Rational))
</span><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#queryAllowedQuadraticNet"><span class="hs-identifier hs-var hs-var">queryAllowedQuadraticNet</span></a></span></span><span> </span><span id="local-6989586621679449861"><span class="annot"><span class="annottext">QuadraticNetConfig
</span><a href="#local-6989586621679449861"><span class="hs-identifier hs-var">qNetConfig</span></a></span></span><span> </span><span id="local-6989586621679449860"><span class="annot"><span class="annottext">Double
</span><a href="#local-6989586621679449860"><span class="hs-identifier hs-var">resolution</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#BilinearForms"><span class="hs-identifier hs-type">BilinearForms</span></a></span><span> </span><span class="annot"><span class="annottext">Double
</span><span class="hs-identifier">_</span></span><span> </span><span id="local-6989586621679449859"><span class="annot"><span class="annottext">[(Maybe (V j Rational), Matrix j j Rational)]
</span><a href="#local-6989586621679449859"><span class="hs-identifier hs-var">fs</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-56"></span><span>  </span><span class="annot"><span class="annottext">Int
-&gt; (forall p. Precision p =&gt; Proxy p -&gt; IO (Maybe (V j Rational)))
-&gt; IO (Maybe (V j Rational))
forall a. Int -&gt; (forall p. Precision p =&gt; Proxy p -&gt; a) -&gt; a
</span><span class="hs-identifier hs-var">reifyPrecision</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">QuadraticNetConfig -&gt; Int
</span><span class="hs-identifier hs-var hs-var">QN.precision</span></span><span> </span><span class="annot"><span class="annottext">QuadraticNetConfig
</span><a href="#local-6989586621679449861"><span class="hs-identifier hs-var">qNetConfig</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">((forall p. Precision p =&gt; Proxy p -&gt; IO (Maybe (V j Rational)))
 -&gt; IO (Maybe (V j Rational)))
-&gt; (forall p. Precision p =&gt; Proxy p -&gt; IO (Maybe (V j Rational)))
-&gt; IO (Maybe (V j Rational))
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span>
</span><span id="line-57"></span><span>    </span><span class="hs-glyph">\</span><span class="hs-special">(</span><span id="local-6989586621679449857"><span class="annot"><span class="annottext">Proxy p
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Proxy</span></span><span> </span><span class="annot"><a href="#local-6989586621679449857"><span class="hs-identifier hs-type">p</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-58"></span><span>      </span><span class="hs-comment">-- We negate the matrices because we want to find a region where</span><span>
</span><span id="line-59"></span><span>      </span><span class="hs-comment">-- all quadratic forms are negative. We rescale so that various</span><span>
</span><span id="line-60"></span><span>      </span><span class="hs-comment">-- thresholds defined in QuadraticNet work correctly.</span><span>
</span><span id="line-61"></span><span>      </span><span class="hs-keyword">let</span><span> </span><span id="local-6989586621679449856"><span class="annot"><span class="annottext">NonEmpty (Matrix j j (Rounded 'TowardZero p))
</span><a href="#local-6989586621679449856"><span class="hs-identifier hs-var">qForms</span></a></span></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">NE.NonEmpty</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">M.Matrix</span></span><span> </span><span class="annot"><a href="#local-6989586621679449888"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679449888"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Rounded</span></span><span> </span><span class="hs-special">'</span><span class="annot"><span class="hs-identifier hs-type">TowardZero</span></span><span> </span><span class="annot"><a href="#local-6989586621679449857"><span class="hs-identifier hs-type">p</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-62"></span><span>            </span><span class="annot"><span class="annottext">Matrix j j Rational -&gt; Matrix j j (Rounded 'TowardZero p)
forall (j :: Nat) a.
(KnownNat j, Fractional a) =&gt;
Matrix j j Rational -&gt; Matrix j j a
</span><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#rescaleNegateMatrix"><span class="hs-identifier hs-var">rescaleNegateMatrix</span></a></span><span> </span><span class="annot"><span class="annottext">(Matrix j j Rational -&gt; Matrix j j (Rounded 'TowardZero p))
-&gt; NonEmpty (Matrix j j Rational)
-&gt; NonEmpty (Matrix j j (Rounded 'TowardZero p))
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-operator hs-var">&lt;$&gt;</span></span><span> </span><span class="annot"><span class="annottext">[Matrix j j Rational] -&gt; NonEmpty (Matrix j j Rational)
forall a. [a] -&gt; NonEmpty a
</span><span class="hs-identifier hs-var">NE.fromList</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">((Maybe (V j Rational), Matrix j j Rational)
 -&gt; Matrix j j Rational)
-&gt; [(Maybe (V j Rational), Matrix j j Rational)]
-&gt; [Matrix j j Rational]
forall a b. (a -&gt; b) -&gt; [a] -&gt; [b]
</span><span class="hs-identifier hs-var">map</span></span><span> </span><span class="annot"><span class="annottext">(Maybe (V j Rational), Matrix j j Rational) -&gt; Matrix j j Rational
forall a b. (a, b) -&gt; b
</span><span class="hs-identifier hs-var">snd</span></span><span> </span><span class="annot"><span class="annottext">[(Maybe (V j Rational), Matrix j j Rational)]
</span><a href="#local-6989586621679449859"><span class="hs-identifier hs-var">fs</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-63"></span><span>      </span><span id="local-6989586621679449852"><span class="annot"><span class="annottext">Maybe (V j (Rounded 'TowardZero p))
</span><a href="#local-6989586621679449852"><span class="hs-identifier hs-var">vMaybe</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span>
</span><span id="line-64"></span><span>        </span><span class="hs-comment">-- withKnownNat (SNat @j %:- SNat @1) $</span><span>
</span><span id="line-65"></span><span>        </span><span class="annot"><span class="annottext">ExceptT Text IO (Maybe (V j (Rounded 'TowardZero p)))
-&gt; IO (Maybe (V j (Rounded 'TowardZero p)))
forall (m :: * -&gt; *) a a.
(Show a, MonadIO m) =&gt;
ExceptT a m (Maybe a) -&gt; m (Maybe a)
</span><a href="#local-6989586621679449851"><span class="hs-identifier hs-var">noteError</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">QuadraticNetConfig
-&gt; NonEmpty (Matrix j j (Rounded 'TowardZero p))
-&gt; ExceptT Text IO (Maybe (V j (Rounded 'TowardZero p)))
forall k (j :: Nat) (r :: RoundingMode) (p :: k).
(KnownNat j, KnownNat (j - 1), Rounding r, Precision p) =&gt;
QuadraticNetConfig
-&gt; NonEmpty (Matrix j j (Rounded r p))
-&gt; ExceptT Text IO (Maybe (V j (Rounded r p)))
</span><span class="hs-identifier hs-var">QN.runSearch</span></span><span> </span><span class="annot"><span class="annottext">QuadraticNetConfig
</span><a href="#local-6989586621679449861"><span class="hs-identifier hs-var">qNetConfig</span></a></span><span> </span><span class="annot"><span class="annottext">NonEmpty (Matrix j j (Rounded 'TowardZero p))
</span><a href="#local-6989586621679449856"><span class="hs-identifier hs-var">qForms</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-66"></span><span>      </span><span class="annot"><span class="annottext">Maybe (V j Rational) -&gt; IO (Maybe (V j Rational))
forall (m :: * -&gt; *) a. Monad m =&gt; a -&gt; m a
</span><span class="hs-identifier hs-var">return</span></span><span> </span><span class="annot"><span class="annottext">(Maybe (V j Rational) -&gt; IO (Maybe (V j Rational)))
-&gt; Maybe (V j Rational) -&gt; IO (Maybe (V j Rational))
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">(V j (Rounded 'TowardZero p) -&gt; V j Rational)
-&gt; Maybe (V j (Rounded 'TowardZero p)) -&gt; Maybe (V j Rational)
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-identifier hs-var">fmap</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">(Rounded 'TowardZero p -&gt; Rational)
-&gt; V j (Rounded 'TowardZero p) -&gt; V j Rational
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-identifier hs-var">fmap</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Rounded 'TowardZero p -&gt; Rounded 'TowardZero p -&gt; Rational
forall a. RealFrac a =&gt; a -&gt; a -&gt; Rational
</span><span class="hs-operator hs-var">`approxRational`</span></span><span> </span><span class="annot"><span class="annottext">Double -&gt; Rounded 'TowardZero p
forall a b. (Real a, Fractional b) =&gt; a -&gt; b
</span><span class="hs-identifier hs-var">realToFrac</span></span><span> </span><span class="annot"><span class="annottext">Double
</span><a href="#local-6989586621679449860"><span class="hs-identifier hs-var">resolution</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">Maybe (V j (Rounded 'TowardZero p))
</span><a href="#local-6989586621679449852"><span class="hs-identifier hs-var">vMaybe</span></a></span><span>
</span><span id="line-67"></span><span>  </span><span class="hs-keyword">where</span><span>
</span><span id="line-68"></span><span>    </span><span id="local-6989586621679449851"><span class="annot"><span class="annottext">noteError :: ExceptT a m (Maybe a) -&gt; m (Maybe a)
</span><a href="#local-6989586621679449851"><span class="hs-identifier hs-var hs-var">noteError</span></a></span></span><span> </span><span id="local-6989586621679449849"><span class="annot"><span class="annottext">ExceptT a m (Maybe a)
</span><a href="#local-6989586621679449849"><span class="hs-identifier hs-var">m</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">ExceptT a m (Maybe a) -&gt; m (Either a (Maybe a))
forall e (m :: * -&gt; *) a. ExceptT e m a -&gt; m (Either e a)
</span><span class="hs-identifier hs-var">runExceptT</span></span><span> </span><span class="annot"><span class="annottext">ExceptT a m (Maybe a)
</span><a href="#local-6989586621679449849"><span class="hs-identifier hs-var">m</span></a></span><span> </span><span class="annot"><span class="annottext">m (Either a (Maybe a))
-&gt; (Either a (Maybe a) -&gt; m (Maybe a)) -&gt; m (Maybe a)
forall (m :: * -&gt; *) a b. Monad m =&gt; m a -&gt; (a -&gt; m b) -&gt; m b
</span><span class="hs-operator hs-var">&gt;&gt;=</span></span><span> </span><span class="hs-glyph">\</span><span class="hs-glyph">case</span><span>
</span><span id="line-69"></span><span>      </span><span class="annot"><span class="hs-identifier hs-type">Left</span></span><span> </span><span id="local-6989586621679449848"><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449848"><span class="hs-identifier hs-var">e</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">Text -&gt; a -&gt; m ()
forall a (m :: * -&gt; *). (Show a, MonadIO m) =&gt; Text -&gt; a -&gt; m ()
</span><span class="hs-identifier hs-var">Log.info</span></span><span> </span><span class="annot"><span class="annottext">Text
</span><span class="hs-string">&quot;QuadraticNet error&quot;</span></span><span> </span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449848"><span class="hs-identifier hs-var">e</span></a></span><span> </span><span class="annot"><span class="annottext">m () -&gt; m (Maybe a) -&gt; m (Maybe a)
forall (m :: * -&gt; *) a b. Monad m =&gt; m a -&gt; m b -&gt; m b
</span><span class="hs-operator hs-var">&gt;&gt;</span></span><span> </span><span class="annot"><span class="annottext">Maybe a -&gt; m (Maybe a)
forall (m :: * -&gt; *) a. Monad m =&gt; a -&gt; m a
</span><span class="hs-identifier hs-var">return</span></span><span> </span><span class="annot"><span class="annottext">Maybe a
forall a. Maybe a
</span><span class="hs-identifier hs-var">Nothing</span></span><span>
</span><span id="line-70"></span><span>      </span><span class="annot"><span class="hs-identifier hs-type">Right</span></span><span> </span><span id="local-6989586621679449846"><span class="annot"><span class="annottext">Maybe a
</span><a href="#local-6989586621679449846"><span class="hs-identifier hs-var">r</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">Maybe a -&gt; m (Maybe a)
forall (m :: * -&gt; *) a. Monad m =&gt; a -&gt; m a
</span><span class="hs-identifier hs-var">return</span></span><span> </span><span class="annot"><span class="annottext">Maybe a
</span><a href="#local-6989586621679449846"><span class="hs-identifier hs-var">r</span></a></span><span>
</span><span id="line-71"></span><span>
</span><span id="line-72"></span><span id="local-6989586621679449929"><span id="local-6989586621679449930"><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#rescaleMatrix"><span class="hs-identifier hs-type">rescaleMatrix</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">KnownNat</span></span><span> </span><span class="annot"><a href="#local-6989586621679449930"><span class="hs-identifier hs-type">j</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Fractional</span></span><span> </span><span class="annot"><a href="#local-6989586621679449929"><span class="hs-identifier hs-type">a</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">M.Matrix</span></span><span> </span><span class="annot"><a href="#local-6989586621679449930"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679449930"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679449929"><span class="hs-identifier hs-type">a</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">M.Matrix</span></span><span> </span><span class="annot"><a href="#local-6989586621679449930"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679449930"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679449929"><span class="hs-identifier hs-type">a</span></a></span></span></span><span>
</span><span id="line-73"></span><span id="rescaleMatrix"><span class="annot"><span class="annottext">rescaleMatrix :: Matrix j j a -&gt; Matrix j j a
</span><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#rescaleMatrix"><span class="hs-identifier hs-var hs-var">rescaleMatrix</span></a></span></span><span> </span><span id="local-6989586621679449844"><span class="annot"><span class="annottext">Matrix j j a
</span><a href="#local-6989586621679449844"><span class="hs-identifier hs-var">m</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(a -&gt; a) -&gt; Matrix j j a -&gt; Matrix j j a
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-identifier hs-var">fmap</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">a -&gt; a -&gt; a
forall a. Fractional a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">/</span></span><span> </span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449842"><span class="hs-identifier hs-var">scale</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">Matrix j j a
</span><a href="#local-6989586621679449844"><span class="hs-identifier hs-var">m</span></a></span><span>
</span><span id="line-74"></span><span>  </span><span class="hs-keyword">where</span><span>
</span><span id="line-75"></span><span>    </span><span id="local-6989586621679449842"><span class="annot"><span class="annottext">scale :: a
</span><a href="#local-6989586621679449842"><span class="hs-identifier hs-var hs-var">scale</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[a] -&gt; a
forall (t :: * -&gt; *) a. (Foldable t, Num a) =&gt; t a -&gt; a
</span><span class="hs-identifier hs-var">sum</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">(a -&gt; a) -&gt; [a] -&gt; [a]
forall a b. (a -&gt; b) -&gt; [a] -&gt; [b]
</span><span class="hs-identifier hs-var">map</span></span><span> </span><span class="annot"><span class="annottext">a -&gt; a
forall a. Num a =&gt; a -&gt; a
</span><span class="hs-identifier hs-var">abs</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Matrix j j a -&gt; [a]
forall (m :: Nat) (n :: Nat) a. Matrix m n a -&gt; [a]
</span><span class="hs-identifier hs-var">M.toList</span></span><span> </span><span class="annot"><span class="annottext">Matrix j j a
</span><a href="#local-6989586621679449844"><span class="hs-identifier hs-var">m</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">a -&gt; a -&gt; a
forall a. Fractional a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">/</span></span><span> </span><span class="annot"><span class="annottext">Int -&gt; a
forall a b. (Integral a, Num b) =&gt; a -&gt; b
</span><span class="hs-identifier hs-var">fromIntegral</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Matrix j j a -&gt; Int
forall (m :: Nat) (n :: Nat) a. KnownNat n =&gt; Matrix m n a -&gt; Int
</span><span class="hs-identifier hs-var">M.ncols</span></span><span> </span><span class="annot"><span class="annottext">Matrix j j a
</span><a href="#local-6989586621679449844"><span class="hs-identifier hs-var">m</span></a></span><span> </span><span class="annot"><span class="annottext">Int -&gt; Int -&gt; Int
forall a. Num a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">*</span></span><span> </span><span class="annot"><span class="annottext">Matrix j j a -&gt; Int
forall (m :: Nat) (n :: Nat) a. KnownNat m =&gt; Matrix m n a -&gt; Int
</span><span class="hs-identifier hs-var">M.nrows</span></span><span> </span><span class="annot"><span class="annottext">Matrix j j a
</span><a href="#local-6989586621679449844"><span class="hs-identifier hs-var">m</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-76"></span><span>
</span><span id="line-77"></span><span id="local-6989586621679449976"><span id="local-6989586621679449977"><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#rescaleNegateMatrix"><span class="hs-identifier hs-type">rescaleNegateMatrix</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">KnownNat</span></span><span> </span><span class="annot"><a href="#local-6989586621679449977"><span class="hs-identifier hs-type">j</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Fractional</span></span><span> </span><span class="annot"><a href="#local-6989586621679449976"><span class="hs-identifier hs-type">a</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">M.Matrix</span></span><span> </span><span class="annot"><a href="#local-6989586621679449977"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679449977"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Rational</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">M.Matrix</span></span><span> </span><span class="annot"><a href="#local-6989586621679449977"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679449977"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679449976"><span class="hs-identifier hs-type">a</span></a></span></span></span><span>
</span><span id="line-78"></span><span id="rescaleNegateMatrix"><span class="annot"><span class="annottext">rescaleNegateMatrix :: Matrix j j Rational -&gt; Matrix j j a
</span><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#rescaleNegateMatrix"><span class="hs-identifier hs-var hs-var">rescaleNegateMatrix</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Matrix j j a -&gt; Matrix j j a
forall (j :: Nat) a.
(KnownNat j, Fractional a) =&gt;
Matrix j j a -&gt; Matrix j j a
</span><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#rescaleMatrix"><span class="hs-identifier hs-var">rescaleMatrix</span></a></span><span> </span><span class="annot"><span class="annottext">(Matrix j j a -&gt; Matrix j j a)
-&gt; (Matrix j j Rational -&gt; Matrix j j a)
-&gt; Matrix j j Rational
-&gt; Matrix j j a
forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Matrix j j a -&gt; Matrix j j a
forall a. Num a =&gt; a -&gt; a
</span><span class="hs-identifier hs-var">negate</span></span><span> </span><span class="annot"><span class="annottext">(Matrix j j a -&gt; Matrix j j a)
-&gt; (Matrix j j Rational -&gt; Matrix j j a)
-&gt; Matrix j j Rational
-&gt; Matrix j j a
forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">(Rational -&gt; a) -&gt; Matrix j j Rational -&gt; Matrix j j a
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-identifier hs-var">fmap</span></span><span> </span><span class="annot"><span class="annottext">Rational -&gt; a
forall a b. (Real a, Fractional b) =&gt; a -&gt; b
</span><span class="hs-identifier hs-var">realToFrac</span></span><span>
</span><span id="line-79"></span><span>
</span><span id="line-80"></span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#queryAllowedDescent"><span class="hs-identifier hs-type">queryAllowedDescent</span></a></span><span>
</span><span id="line-81"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679449895"><span class="annot"><a href="#local-6989586621679449895"><span class="hs-identifier hs-type">j</span></a></span></span><span> </span><span class="hs-operator">.</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">KnownNat</span></span><span> </span><span class="annot"><a href="#local-6989586621679449895"><span class="hs-identifier hs-type">j</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-number">1</span></span><span> </span><span class="annot"><span class="hs-operator hs-type">&lt;=</span></span><span> </span><span class="annot"><a href="#local-6989586621679449895"><span class="hs-identifier hs-type">j</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-82"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.HessianLineSearch.html#DescentConfig"><span class="hs-identifier hs-type">DescentConfig</span></a></span><span>
</span><span id="line-83"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Int</span></span><span>
</span><span id="line-84"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Double</span></span><span>
</span><span id="line-85"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Int</span></span><span>
</span><span id="line-86"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Int</span></span><span>
</span><span id="line-87"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#BilinearForms"><span class="hs-identifier hs-type">BilinearForms</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679449895"><span class="hs-identifier hs-type">j</span></a></span><span>
</span><span id="line-88"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Maybe</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">V</span></span><span> </span><span class="annot"><a href="#local-6989586621679449895"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Rational</span></span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-89"></span><span id="queryAllowedDescent"><span class="annot"><span class="annottext">queryAllowedDescent :: DescentConfig
-&gt; Int
-&gt; Double
-&gt; Int
-&gt; Int
-&gt; BilinearForms j
-&gt; IO (Maybe (V j Rational))
</span><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#queryAllowedDescent"><span class="hs-identifier hs-var hs-var">queryAllowedDescent</span></a></span></span><span> </span><span id="local-6989586621679449834"><span class="annot"><span class="annottext">DescentConfig
</span><a href="#local-6989586621679449834"><span class="hs-identifier hs-var">descentConfig</span></a></span></span><span> </span><span id="local-6989586621679449833"><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679449833"><span class="hs-identifier hs-var">prec</span></a></span></span><span> </span><span id="local-6989586621679449832"><span class="annot"><span class="annottext">Double
</span><a href="#local-6989586621679449832"><span class="hs-identifier hs-var">resolution</span></a></span></span><span> </span><span id="local-6989586621679449831"><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679449831"><span class="hs-identifier hs-var">hessianLineSteps</span></a></span></span><span> </span><span id="local-6989586621679449830"><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679449830"><span class="hs-identifier hs-var">hessianLineAverage</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#BilinearForms"><span class="hs-identifier hs-type">BilinearForms</span></a></span><span> </span><span class="annot"><span class="annottext">Double
</span><span class="hs-identifier">_</span></span><span> </span><span id="local-6989586621679449829"><span class="annot"><span class="annottext">[(Maybe (V j Rational), Matrix j j Rational)]
</span><a href="#local-6989586621679449829"><span class="hs-identifier hs-var">qs</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-90"></span><span>  </span><span class="annot"><span class="annottext">Int
-&gt; (forall p. Precision p =&gt; Proxy p -&gt; IO (Maybe (V j Rational)))
-&gt; IO (Maybe (V j Rational))
forall a. Int -&gt; (forall p. Precision p =&gt; Proxy p -&gt; a) -&gt; a
</span><span class="hs-identifier hs-var">reifyPrecision</span></span><span> </span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679449833"><span class="hs-identifier hs-var">prec</span></a></span><span> </span><span class="annot"><span class="annottext">((forall p. Precision p =&gt; Proxy p -&gt; IO (Maybe (V j Rational)))
 -&gt; IO (Maybe (V j Rational)))
-&gt; (forall p. Precision p =&gt; Proxy p -&gt; IO (Maybe (V j Rational)))
-&gt; IO (Maybe (V j Rational))
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span>
</span><span id="line-91"></span><span>  </span><span class="hs-glyph">\</span><span class="hs-special">(</span><span id="local-6989586621679449828"><span class="annot"><span class="annottext">Proxy p
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Proxy</span></span><span> </span><span class="annot"><a href="#local-6989586621679449828"><span class="hs-identifier hs-type">p</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-keyword">case</span><span> </span><span class="annot"><span class="annottext">[(Maybe (V j Rational), Matrix j j Rational)]
</span><a href="#local-6989586621679449829"><span class="hs-identifier hs-var">qs</span></a></span><span> </span><span class="hs-keyword">of</span><span>
</span><span id="line-92"></span><span>    </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Maybe (V j Rational)
</span><span class="hs-identifier">_</span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679449827"><span class="annot"><span class="annottext">Matrix j j Rational
</span><a href="#local-6989586621679449827"><span class="hs-identifier hs-var">qNewR</span></a></span></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="hs-glyph hs-type">:</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Just</span></span><span> </span><span id="local-6989586621679449826"><span class="annot"><span class="annottext">V j Rational
</span><a href="#local-6989586621679449826"><span class="hs-identifier hs-var">lambdaPrevR</span></a></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679449825"><span class="annot"><span class="annottext">Matrix j j Rational
</span><a href="#local-6989586621679449825"><span class="hs-identifier hs-var">qForm'R</span></a></span></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="hs-glyph hs-type">:</span></span><span> </span><span id="local-6989586621679449824"><span class="annot"><span class="annottext">[(Maybe (V j Rational), Matrix j j Rational)]
</span><a href="#local-6989586621679449824"><span class="hs-identifier hs-var">qFormsR</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-93"></span><span>      </span><span class="hs-keyword">let</span><span> </span><span id="local-6989586621679449823"><span class="annot"><span class="annottext">V j (Rounded 'TowardZero p)
</span><a href="#local-6989586621679449823"><span class="hs-identifier hs-var">lambdaPrev</span></a></span></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">V</span></span><span> </span><span class="annot"><a href="#local-6989586621679449895"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Rounded</span></span><span> </span><span class="hs-special">'</span><span class="annot"><span class="hs-identifier hs-type">TowardZero</span></span><span> </span><span class="annot"><a href="#local-6989586621679449828"><span class="hs-identifier hs-type">p</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(Rational -&gt; Rounded 'TowardZero p)
-&gt; V j Rational -&gt; V j (Rounded 'TowardZero p)
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-identifier hs-var">fmap</span></span><span> </span><span class="annot"><span class="annottext">Rational -&gt; Rounded 'TowardZero p
forall a b. (Real a, Fractional b) =&gt; a -&gt; b
</span><span class="hs-identifier hs-var">realToFrac</span></span><span> </span><span class="annot"><span class="annottext">V j Rational
</span><a href="#local-6989586621679449826"><span class="hs-identifier hs-var">lambdaPrevR</span></a></span><span>
</span><span id="line-94"></span><span>          </span><span id="local-6989586621679449822"><span class="annot"><span class="annottext">qNew :: Matrix j j (Rounded 'TowardZero p)
</span><a href="#local-6989586621679449822"><span class="hs-identifier hs-var hs-var">qNew</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Matrix j j Rational -&gt; Matrix j j (Rounded 'TowardZero p)
forall (j :: Nat) a.
(KnownNat j, Fractional a) =&gt;
Matrix j j Rational -&gt; Matrix j j a
</span><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#rescaleNegateMatrix"><span class="hs-identifier hs-var">rescaleNegateMatrix</span></a></span><span> </span><span class="annot"><span class="annottext">Matrix j j Rational
</span><a href="#local-6989586621679449827"><span class="hs-identifier hs-var">qNewR</span></a></span><span>
</span><span id="line-95"></span><span>          </span><span id="local-6989586621679449821"><span class="annot"><span class="annottext">qForms :: NonEmpty (Matrix j j (Rounded 'TowardZero p))
</span><a href="#local-6989586621679449821"><span class="hs-identifier hs-var hs-var">qForms</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Matrix j j Rational -&gt; Matrix j j (Rounded 'TowardZero p)
forall (j :: Nat) a.
(KnownNat j, Fractional a) =&gt;
Matrix j j Rational -&gt; Matrix j j a
</span><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#rescaleNegateMatrix"><span class="hs-identifier hs-var">rescaleNegateMatrix</span></a></span><span> </span><span class="annot"><span class="annottext">(Matrix j j Rational -&gt; Matrix j j (Rounded 'TowardZero p))
-&gt; NonEmpty (Matrix j j Rational)
-&gt; NonEmpty (Matrix j j (Rounded 'TowardZero p))
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-operator hs-var">&lt;$&gt;</span></span><span> </span><span class="annot"><span class="annottext">Matrix j j Rational
</span><a href="#local-6989586621679449825"><span class="hs-identifier hs-var">qForm'R</span></a></span><span> </span><span class="annot"><span class="annottext">Matrix j j Rational
-&gt; [Matrix j j Rational] -&gt; NonEmpty (Matrix j j Rational)
forall a. a -&gt; [a] -&gt; NonEmpty a
</span><span class="hs-operator hs-var">:|</span></span><span> </span><span class="annot"><span class="annottext">((Maybe (V j Rational), Matrix j j Rational)
 -&gt; Matrix j j Rational)
-&gt; [(Maybe (V j Rational), Matrix j j Rational)]
-&gt; [Matrix j j Rational]
forall a b. (a -&gt; b) -&gt; [a] -&gt; [b]
</span><span class="hs-identifier hs-var">map</span></span><span> </span><span class="annot"><span class="annottext">(Maybe (V j Rational), Matrix j j Rational) -&gt; Matrix j j Rational
forall a b. (a, b) -&gt; b
</span><span class="hs-identifier hs-var">snd</span></span><span> </span><span class="annot"><span class="annottext">[(Maybe (V j Rational), Matrix j j Rational)]
</span><a href="#local-6989586621679449824"><span class="hs-identifier hs-var">qFormsR</span></a></span><span>
</span><span id="line-96"></span><span>      </span><span class="annot"><span class="annottext">Text -&gt; IO ()
forall (m :: * -&gt; *). MonadIO m =&gt; Text -&gt; m ()
</span><span class="hs-identifier hs-var">Log.text</span></span><span> </span><span class="annot"><span class="annottext">(Text -&gt; IO ()) -&gt; Text -&gt; IO ()
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span>
</span><span id="line-97"></span><span>        </span><span class="annot"><span class="annottext">Builder
</span><span class="hs-string">&quot;Starting descent search with &quot;</span></span><span class="annot"><span class="annottext">Builder -&gt; Builder -&gt; Text
forall b. FromBuilder b =&gt; Builder -&gt; Builder -&gt; b
</span><span class="hs-operator hs-var">+||</span></span><span class="annot"><span class="annottext">NonEmpty (Matrix j j (Rounded 'TowardZero p)) -&gt; Int
forall (t :: * -&gt; *) a. Foldable t =&gt; t a -&gt; Int
</span><span class="hs-identifier hs-var">length</span></span><span> </span><span class="annot"><span class="annottext">NonEmpty (Matrix j j (Rounded 'TowardZero p))
</span><a href="#local-6989586621679449821"><span class="hs-identifier hs-var">qForms</span></a></span><span> </span><span class="annot"><span class="annottext">Int -&gt; Int -&gt; Int
forall a. Num a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">+</span></span><span> </span><span class="annot"><span class="annottext">Int
</span><span class="hs-number">1</span></span><span class="annot"><span class="annottext">Int -&gt; Builder -&gt; Builder
forall a b. (Show a, FromBuilder b) =&gt; a -&gt; Builder -&gt; b
</span><span class="hs-operator hs-var">||+</span></span><span>
</span><span id="line-98"></span><span>        </span><span class="annot"><span class="annottext">Builder
</span><span class="hs-string">&quot; quadratic forms of size &quot;</span></span><span class="annot"><span class="annottext">Builder -&gt; Builder -&gt; Builder
forall b. FromBuilder b =&gt; Builder -&gt; Builder -&gt; b
</span><span class="hs-operator hs-var">+||</span></span><span class="annot"><span class="annottext">Matrix j j (Rounded 'TowardZero p) -&gt; Int
forall (m :: Nat) (n :: Nat) a. KnownNat m =&gt; Matrix m n a -&gt; Int
</span><span class="hs-identifier hs-var">M.nrows</span></span><span> </span><span class="annot"><span class="annottext">Matrix j j (Rounded 'TowardZero p)
</span><a href="#local-6989586621679449822"><span class="hs-identifier hs-var">qNew</span></a></span><span class="annot"><span class="annottext">Int -&gt; Builder -&gt; Builder
forall a b. (Show a, FromBuilder b) =&gt; a -&gt; Builder -&gt; b
</span><span class="hs-operator hs-var">||+</span></span><span>
</span><span id="line-99"></span><span>        </span><span class="annot"><span class="annottext">Builder
</span><span class="hs-string">&quot;x&quot;</span></span><span class="annot"><span class="annottext">Builder -&gt; Builder -&gt; Builder
forall b. FromBuilder b =&gt; Builder -&gt; Builder -&gt; b
</span><span class="hs-operator hs-var">+||</span></span><span class="annot"><span class="annottext">Matrix j j (Rounded 'TowardZero p) -&gt; Int
forall (m :: Nat) (n :: Nat) a. KnownNat n =&gt; Matrix m n a -&gt; Int
</span><span class="hs-identifier hs-var">M.ncols</span></span><span> </span><span class="annot"><span class="annottext">Matrix j j (Rounded 'TowardZero p)
</span><a href="#local-6989586621679449822"><span class="hs-identifier hs-var">qNew</span></a></span><span class="annot"><span class="annottext">Int -&gt; Builder -&gt; Builder
forall a b. (Show a, FromBuilder b) =&gt; a -&gt; Builder -&gt; b
</span><span class="hs-operator hs-var">||+</span></span><span class="annot"><span class="annottext">Builder
</span><span class="hs-string">&quot;&quot;</span></span><span>
</span><span id="line-100"></span><span>      </span><span class="annot"><span class="annottext">DescentConfig
-&gt; NonEmpty (Matrix j j (Rounded 'TowardZero p))
-&gt; Matrix j j (Rounded 'TowardZero p)
-&gt; V j (Rounded 'TowardZero p)
-&gt; IO (DescentResult (V j (Rounded 'TowardZero p)))
forall k (j :: Nat) (r :: RoundingMode) (p :: k).
(KnownNat j, 1 &lt;= j, Rounding r, Precision p) =&gt;
DescentConfig
-&gt; NonEmpty (Matrix j j (Rounded r p))
-&gt; Matrix j j (Rounded r p)
-&gt; V j (Rounded r p)
-&gt; IO (DescentResult (V j (Rounded r p)))
</span><a href="Hyperion.Bootstrap.OPESearch.HessianLineSearch.html#descentSearchRandomized"><span class="hs-identifier hs-var">descentSearchRandomized</span></a></span><span> </span><span class="annot"><span class="annottext">DescentConfig
</span><a href="#local-6989586621679449834"><span class="hs-identifier hs-var">descentConfig</span></a></span><span> </span><span class="annot"><span class="annottext">NonEmpty (Matrix j j (Rounded 'TowardZero p))
</span><a href="#local-6989586621679449821"><span class="hs-identifier hs-var">qForms</span></a></span><span> </span><span class="annot"><span class="annottext">Matrix j j (Rounded 'TowardZero p)
</span><a href="#local-6989586621679449822"><span class="hs-identifier hs-var">qNew</span></a></span><span> </span><span class="annot"><span class="annottext">V j (Rounded 'TowardZero p)
</span><a href="#local-6989586621679449823"><span class="hs-identifier hs-var">lambdaPrev</span></a></span><span> </span><span class="annot"><span class="annottext">IO (DescentResult (V j (Rounded 'TowardZero p)))
-&gt; (DescentResult (V j (Rounded 'TowardZero p))
    -&gt; IO (Maybe (V j Rational)))
-&gt; IO (Maybe (V j Rational))
forall (m :: * -&gt; *) a b. Monad m =&gt; m a -&gt; (a -&gt; m b) -&gt; m b
</span><span class="hs-operator hs-var">&gt;&gt;=</span></span><span> </span><span class="hs-glyph">\</span><span class="hs-glyph">case</span><span>
</span><span id="line-101"></span><span>        </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.HessianLineSearch.html#Feasible"><span class="hs-identifier hs-type">Feasible</span></a></span><span> </span><span id="local-6989586621679449815"><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679449815"><span class="hs-identifier hs-var">n</span></a></span></span><span> </span><span id="local-6989586621679449814"><span class="annot"><span class="annottext">Double
</span><a href="#local-6989586621679449814"><span class="hs-identifier hs-var">tilt</span></a></span></span><span> </span><span id="local-6989586621679449813"><span class="annot"><span class="annottext">V j (Rounded 'TowardZero p)
</span><a href="#local-6989586621679449813"><span class="hs-identifier hs-var">lambda</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-102"></span><span>          </span><span class="annot"><span class="annottext">Text -&gt; (Int, Double, V j (Rounded 'TowardZero p)) -&gt; IO ()
forall a (m :: * -&gt; *). (Show a, MonadIO m) =&gt; Text -&gt; a -&gt; m ()
</span><span class="hs-identifier hs-var">Log.info</span></span><span> </span><span class="annot"><span class="annottext">Text
</span><span class="hs-string">&quot;Descent search succeeded&quot;</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679449815"><span class="hs-identifier hs-var">n</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Double
</span><a href="#local-6989586621679449814"><span class="hs-identifier hs-var">tilt</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">V j (Rounded 'TowardZero p)
</span><a href="#local-6989586621679449813"><span class="hs-identifier hs-var">lambda</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-103"></span><span>          </span><span id="local-6989586621679449812"><span class="annot"><span class="annottext">V j (Rounded 'TowardZero p)
</span><a href="#local-6989586621679449812"><span class="hs-identifier hs-var">lambda'</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="annot"><span class="annottext">LineSearchType
-&gt; NonEmpty (Matrix j j (Rounded 'TowardZero p))
-&gt; V j (Rounded 'TowardZero p)
-&gt; Int
-&gt; Int
-&gt; IO (V j (Rounded 'TowardZero p))
forall k (j :: Nat) (r :: RoundingMode) (p :: k).
(KnownNat j, 1 &lt;= j, Rounding r, Precision p) =&gt;
LineSearchType
-&gt; NonEmpty (Matrix j j (Rounded r p))
-&gt; V j (Rounded r p)
-&gt; Int
-&gt; Int
-&gt; IO (V j (Rounded r p))
</span><a href="Hyperion.Bootstrap.OPESearch.HessianLineSearch.html#hessianLineSearchAverage"><span class="hs-identifier hs-var">hessianLineSearchAverage</span></a></span><span> </span><span class="annot"><span class="annottext">LineSearchType
</span><a href="Hyperion.Bootstrap.OPESearch.HessianLineSearch.html#MidPoint"><span class="hs-identifier hs-var">MidPoint</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Matrix j j (Rounded 'TowardZero p)
</span><a href="#local-6989586621679449822"><span class="hs-identifier hs-var">qNew</span></a></span><span> </span><span class="annot"><span class="annottext">Matrix j j (Rounded 'TowardZero p)
-&gt; NonEmpty (Matrix j j (Rounded 'TowardZero p))
-&gt; NonEmpty (Matrix j j (Rounded 'TowardZero p))
forall a. a -&gt; NonEmpty a -&gt; NonEmpty a
</span><span class="hs-operator hs-var">&lt;|</span></span><span> </span><span class="annot"><span class="annottext">NonEmpty (Matrix j j (Rounded 'TowardZero p))
</span><a href="#local-6989586621679449821"><span class="hs-identifier hs-var">qForms</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">V j (Rounded 'TowardZero p)
</span><a href="#local-6989586621679449813"><span class="hs-identifier hs-var">lambda</span></a></span><span> </span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679449831"><span class="hs-identifier hs-var">hessianLineSteps</span></a></span><span> </span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679449830"><span class="hs-identifier hs-var">hessianLineAverage</span></a></span><span>
</span><span id="line-104"></span><span>          </span><span class="annot"><span class="annottext">Maybe (V j Rational) -&gt; IO (Maybe (V j Rational))
forall (m :: * -&gt; *) a. Monad m =&gt; a -&gt; m a
</span><span class="hs-identifier hs-var">return</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">V j Rational -&gt; Maybe (V j Rational)
forall a. a -&gt; Maybe a
</span><span class="hs-identifier hs-var">Just</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">(Rounded 'TowardZero p -&gt; Rational)
-&gt; V j (Rounded 'TowardZero p) -&gt; V j Rational
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-identifier hs-var">fmap</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Rounded 'TowardZero p -&gt; Rounded 'TowardZero p -&gt; Rational
forall a. RealFrac a =&gt; a -&gt; a -&gt; Rational
</span><span class="hs-operator hs-var">`approxRational`</span></span><span> </span><span class="annot"><span class="annottext">Double -&gt; Rounded 'TowardZero p
forall a b. (Real a, Fractional b) =&gt; a -&gt; b
</span><span class="hs-identifier hs-var">realToFrac</span></span><span> </span><span class="annot"><span class="annottext">Double
</span><a href="#local-6989586621679449832"><span class="hs-identifier hs-var">resolution</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">V j (Rounded 'TowardZero p)
</span><a href="#local-6989586621679449812"><span class="hs-identifier hs-var">lambda'</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-105"></span><span>        </span><span class="annot"><span class="annottext">DescentResult (V j (Rounded 'TowardZero p))
</span><a href="Hyperion.Bootstrap.OPESearch.HessianLineSearch.html#Infeasible"><span class="hs-identifier hs-var">Infeasible</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-106"></span><span>          </span><span class="annot"><span class="annottext">Text -&gt; IO ()
forall (m :: * -&gt; *). MonadIO m =&gt; Text -&gt; m ()
</span><span class="hs-identifier hs-var">Log.text</span></span><span> </span><span class="annot"><span class="annottext">Text
</span><span class="hs-string">&quot;Descent search failed.&quot;</span></span><span>
</span><span id="line-107"></span><span>          </span><span class="annot"><span class="annottext">Maybe (V j Rational) -&gt; IO (Maybe (V j Rational))
forall (m :: * -&gt; *) a. Monad m =&gt; a -&gt; m a
</span><span class="hs-identifier hs-var">return</span></span><span> </span><span class="annot"><span class="annottext">Maybe (V j Rational)
forall a. Maybe a
</span><span class="hs-identifier hs-var">Nothing</span></span><span>
</span><span id="line-108"></span><span>    </span><span class="annot"><span class="annottext">[(Maybe (V j Rational), Matrix j j Rational)]
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">Maybe (V j Rational) -&gt; IO (Maybe (V j Rational))
forall (m :: * -&gt; *) a. Monad m =&gt; a -&gt; m a
</span><span class="hs-identifier hs-var">return</span></span><span> </span><span class="annot"><span class="annottext">Maybe (V j Rational)
forall a. Maybe a
</span><span class="hs-identifier hs-var">Nothing</span></span><span>
</span><span id="line-109"></span><span>
</span><span id="line-110"></span><span class="hs-keyword">data</span><span> </span><span id="QueryMixedConfig"><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#QueryMixedConfig"><span class="hs-identifier hs-var">QueryMixedConfig</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span id="QueryMixedConfig"><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#QueryMixedConfig"><span class="hs-identifier hs-var">QueryMixedConfig</span></a></span></span><span>
</span><span id="line-111"></span><span>  </span><span class="hs-special">{</span><span> </span><span id="qmDescentConfig"><span class="annot"><span class="annottext">QueryMixedConfig -&gt; DescentConfig
</span><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#qmDescentConfig"><span class="hs-identifier hs-var hs-var">qmDescentConfig</span></a></span></span><span>      </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.HessianLineSearch.html#DescentConfig"><span class="hs-identifier hs-type">DescentConfig</span></a></span><span>
</span><span id="line-112"></span><span>  </span><span class="hs-special">,</span><span> </span><span id="qmQuadraticNetConfig"><span class="annot"><span class="annottext">QueryMixedConfig -&gt; QuadraticNetConfig
</span><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#qmQuadraticNetConfig"><span class="hs-identifier hs-var hs-var">qmQuadraticNetConfig</span></a></span></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">QN.QuadraticNetConfig</span></span><span>
</span><span id="line-113"></span><span>  </span><span class="hs-special">,</span><span> </span><span id="qmPrecision"><span class="annot"><span class="annottext">QueryMixedConfig -&gt; Int
</span><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#qmPrecision"><span class="hs-identifier hs-var hs-var">qmPrecision</span></a></span></span><span>          </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Int</span></span><span>
</span><span id="line-114"></span><span>  </span><span class="hs-special">,</span><span> </span><span id="qmResolution"><span class="annot"><span class="annottext">QueryMixedConfig -&gt; Double
</span><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#qmResolution"><span class="hs-identifier hs-var hs-var">qmResolution</span></a></span></span><span>         </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Double</span></span><span>
</span><span id="line-115"></span><span>  </span><span class="hs-special">,</span><span> </span><span id="qmHessianLineSteps"><span class="annot"><span class="annottext">QueryMixedConfig -&gt; Int
</span><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#qmHessianLineSteps"><span class="hs-identifier hs-var hs-var">qmHessianLineSteps</span></a></span></span><span>   </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Int</span></span><span>
</span><span id="line-116"></span><span>  </span><span class="hs-special">,</span><span> </span><span id="qmHessianLineAverage"><span class="annot"><span class="annottext">QueryMixedConfig -&gt; Int
</span><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#qmHessianLineAverage"><span class="hs-identifier hs-var hs-var">qmHessianLineAverage</span></a></span></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Int</span></span><span>
</span><span id="line-117"></span><span>  </span><span class="hs-special">}</span><span>
</span><span id="line-118"></span><span>
</span><span id="line-119"></span><span id="local-6989586621679449802"><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#queryAllowedMixed"><span class="hs-identifier hs-type">queryAllowedMixed</span></a></span><span>
</span><span id="line-120"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">KnownNat</span></span><span> </span><span class="annot"><a href="#local-6989586621679449802"><span class="hs-identifier hs-type">j</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">KnownNat</span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="#local-6989586621679449802"><span class="hs-identifier hs-type">j</span></a></span><span class="annot"><span class="hs-glyph hs-type">-</span></span><span class="annot"><span class="hs-number">1</span></span><span class="hs-special">)</span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-number">1</span></span><span> </span><span class="annot"><span class="hs-operator hs-type">&lt;=</span></span><span> </span><span class="annot"><a href="#local-6989586621679449802"><span class="hs-identifier hs-type">j</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-121"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#QueryMixedConfig"><span class="hs-identifier hs-type">QueryMixedConfig</span></a></span><span>
</span><span id="line-122"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#BilinearForms"><span class="hs-identifier hs-type">BilinearForms</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679449802"><span class="hs-identifier hs-type">j</span></a></span><span>
</span><span id="line-123"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Maybe</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">V</span></span><span> </span><span class="annot"><a href="#local-6989586621679449802"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Rational</span></span><span class="hs-special">)</span><span class="hs-special">)</span></span><span>
</span><span id="line-124"></span><span id="queryAllowedMixed"><span class="annot"><span class="annottext">queryAllowedMixed :: QueryMixedConfig -&gt; BilinearForms j -&gt; IO (Maybe (V j Rational))
</span><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#queryAllowedMixed"><span class="hs-identifier hs-var hs-var">queryAllowedMixed</span></a></span></span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#QueryMixedConfig"><span class="hs-identifier hs-type">QueryMixedConfig</span></a></span><span class="hs-special">{</span><span id="local-6989586621679449795"><span id="local-6989586621679449796"><span id="local-6989586621679449797"><span id="local-6989586621679449798"><span id="local-6989586621679449799"><span id="local-6989586621679449800"><span class="annot"><span class="annottext">Double
Int
DescentConfig
QuadraticNetConfig
qmHessianLineAverage :: Int
qmHessianLineSteps :: Int
qmResolution :: Double
qmPrecision :: Int
qmQuadraticNetConfig :: QuadraticNetConfig
qmDescentConfig :: DescentConfig
qmHessianLineAverage :: QueryMixedConfig -&gt; Int
qmHessianLineSteps :: QueryMixedConfig -&gt; Int
qmResolution :: QueryMixedConfig -&gt; Double
qmPrecision :: QueryMixedConfig -&gt; Int
qmQuadraticNetConfig :: QueryMixedConfig -&gt; QuadraticNetConfig
qmDescentConfig :: QueryMixedConfig -&gt; DescentConfig
</span><a href="#local-6989586621679449795"><span class="hs-glyph hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var">..</span></a></span></span></span></span></span></span></span><span class="hs-special">}</span><span> </span><span id="local-6989586621679449794"><span class="annot"><span class="annottext">BilinearForms j
</span><a href="#local-6989586621679449794"><span class="hs-identifier hs-var">b</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-125"></span><span>  </span><span class="annot"><span class="annottext">MaybeT IO (V j Rational) -&gt; IO (Maybe (V j Rational))
forall (m :: * -&gt; *) a. MaybeT m a -&gt; m (Maybe a)
</span><span class="hs-identifier hs-var hs-var">runMaybeT</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">IO (Maybe (V j Rational)) -&gt; MaybeT IO (V j Rational)
forall (m :: * -&gt; *) a. m (Maybe a) -&gt; MaybeT m a
</span><span class="hs-identifier hs-var">MaybeT</span></span><span> </span><span class="annot"><span class="annottext">IO (Maybe (V j Rational))
</span><a href="#local-6989586621679449792"><span class="hs-identifier hs-var">tryDescent</span></a></span><span> </span><span class="annot"><span class="annottext">MaybeT IO (V j Rational)
-&gt; MaybeT IO (V j Rational) -&gt; MaybeT IO (V j Rational)
forall (f :: * -&gt; *) a. Alternative f =&gt; f a -&gt; f a -&gt; f a
</span><span class="hs-operator hs-var">&lt;|&gt;</span></span><span> </span><span class="annot"><span class="annottext">IO (Maybe (V j Rational)) -&gt; MaybeT IO (V j Rational)
forall (m :: * -&gt; *) a. m (Maybe a) -&gt; MaybeT m a
</span><span class="hs-identifier hs-var">MaybeT</span></span><span> </span><span class="annot"><span class="annottext">IO (Maybe (V j Rational))
</span><a href="#local-6989586621679449791"><span class="hs-identifier hs-var">tryQN</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-126"></span><span>  </span><span class="hs-keyword">where</span><span>
</span><span id="line-127"></span><span>    </span><span id="local-6989586621679449792"><span class="annot"><span class="annottext">tryDescent :: IO (Maybe (V j Rational))
</span><a href="#local-6989586621679449792"><span class="hs-identifier hs-var hs-var">tryDescent</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-128"></span><span>      </span><span class="annot"><span class="annottext">DescentConfig
-&gt; Int
-&gt; Double
-&gt; Int
-&gt; Int
-&gt; BilinearForms j
-&gt; IO (Maybe (V j Rational))
forall (j :: Nat).
(KnownNat j, 1 &lt;= j) =&gt;
DescentConfig
-&gt; Int
-&gt; Double
-&gt; Int
-&gt; Int
-&gt; BilinearForms j
-&gt; IO (Maybe (V j Rational))
</span><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#queryAllowedDescent"><span class="hs-identifier hs-var">queryAllowedDescent</span></a></span><span> </span><span class="annot"><span class="annottext">DescentConfig
</span><a href="#local-6989586621679449800"><span class="hs-identifier hs-var">qmDescentConfig</span></a></span><span> </span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679449798"><span class="hs-identifier hs-var">qmPrecision</span></a></span><span> </span><span class="annot"><span class="annottext">Double
</span><a href="#local-6989586621679449797"><span class="hs-identifier hs-var">qmResolution</span></a></span><span> </span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679449796"><span class="hs-identifier hs-var">qmHessianLineSteps</span></a></span><span> </span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679449795"><span class="hs-identifier hs-var">qmHessianLineAverage</span></a></span><span> </span><span class="annot"><span class="annottext">BilinearForms j
</span><a href="#local-6989586621679449794"><span class="hs-identifier hs-var">b</span></a></span><span>
</span><span id="line-129"></span><span>      </span><span class="annot"><span class="annottext">IO (Maybe (V j Rational))
-&gt; (HessianLineSearchError -&gt; IO (Maybe (V j Rational)))
-&gt; IO (Maybe (V j Rational))
forall (m :: * -&gt; *) e a.
(MonadCatch m, Exception e) =&gt;
m a -&gt; (e -&gt; m a) -&gt; m a
</span><span class="hs-operator hs-var">`catch`</span></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">\</span><span class="hs-special">(</span><span id="local-6989586621679449790"><span class="annot"><span class="annottext">HessianLineSearchError
</span><a href="#local-6989586621679449790"><span class="hs-identifier hs-var">e</span></a></span></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.HessianLineSearch.html#HessianLineSearchError"><span class="hs-identifier hs-type">HessianLineSearchError</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">Text -&gt; HessianLineSearchError -&gt; IO ()
forall a (m :: * -&gt; *). (Show a, MonadIO m) =&gt; Text -&gt; a -&gt; m ()
</span><span class="hs-identifier hs-var">Log.info</span></span><span> </span><span class="annot"><span class="annottext">Text
</span><span class="hs-string">&quot;HessianLineSearchError&quot;</span></span><span> </span><span class="annot"><span class="annottext">HessianLineSearchError
</span><a href="#local-6989586621679449790"><span class="hs-identifier hs-var">e</span></a></span><span> </span><span class="annot"><span class="annottext">IO () -&gt; IO (Maybe (V j Rational)) -&gt; IO (Maybe (V j Rational))
forall (m :: * -&gt; *) a b. Monad m =&gt; m a -&gt; m b -&gt; m b
</span><span class="hs-operator hs-var">&gt;&gt;</span></span><span> </span><span class="annot"><span class="annottext">Maybe (V j Rational) -&gt; IO (Maybe (V j Rational))
forall (m :: * -&gt; *) a. Monad m =&gt; a -&gt; m a
</span><span class="hs-identifier hs-var">return</span></span><span> </span><span class="annot"><span class="annottext">Maybe (V j Rational)
forall a. Maybe a
</span><span class="hs-identifier hs-var">Nothing</span></span><span class="hs-special">)</span><span>
</span><span id="line-130"></span><span>    </span><span id="local-6989586621679449791"><span class="annot"><span class="annottext">tryQN :: IO (Maybe (V j Rational))
</span><a href="#local-6989586621679449791"><span class="hs-identifier hs-var hs-var">tryQN</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">QuadraticNetConfig
-&gt; Double -&gt; BilinearForms j -&gt; IO (Maybe (V j Rational))
forall (j :: Nat).
(KnownNat j, KnownNat (j - 1)) =&gt;
QuadraticNetConfig
-&gt; Double -&gt; BilinearForms j -&gt; IO (Maybe (V j Rational))
</span><a href="Hyperion.Bootstrap.OPESearch.FormQueries.html#queryAllowedQuadraticNet"><span class="hs-identifier hs-var">queryAllowedQuadraticNet</span></a></span><span> </span><span class="annot"><span class="annottext">QuadraticNetConfig
</span><a href="#local-6989586621679449799"><span class="hs-identifier hs-var">qmQuadraticNetConfig</span></a></span><span> </span><span class="annot"><span class="annottext">Double
</span><a href="#local-6989586621679449797"><span class="hs-identifier hs-var">qmResolution</span></a></span><span> </span><span class="annot"><span class="annottext">BilinearForms j
</span><a href="#local-6989586621679449794"><span class="hs-identifier hs-var">b</span></a></span><span>
</span><span id="line-131"></span><span>
</span><span id="line-132"></span></pre></body></html>